declare type Multiple<T> = T | T[];
declare type Nullable<T> = T | null | undefined;
export declare type MatchFunction = (source: string, state: ParserState) => Nullable<RegExpMatchArray>;
export declare type Parser = (source: string, state?: ParserState) => ASTNode[];
export declare type ParseFunction = (source: RegExpMatchArray, nestedParse: Parser, state: ParserState) => TypeOptionalASTNode;
export declare type QualityFunction = (capture: RegExpMatchArray, state: ParserState) => number;
export interface ParserState {
    inline: boolean;
    prevCapture?: RegExpMatchArray;
    [key: string]: any;
}
export interface ParserRule {
    name: string;
    match: MatchFunction;
    parse: ParseFunction;
    quality?: QualityFunction;
    svelte?: Svelte2TsxComponent;
}
export interface ASTNode {
    type: string;
    content?: ASTNode[] | string;
    [key: string]: any;
}
export declare type TypeOptionalASTNode = Omit<ASTNode, 'type'> & {
    type?: string;
};
export declare type Rules = Record<string, ParserRule>;
export interface RefNode {
    type: string;
    content?: Multiple<ASTNode>;
    target?: string;
    title?: string;
    alt?: string;
}
export {};
