import type { MatchFunction, Parser, ParserState } from './type';
/** Creates a match function for an inline scoped element from a regex */
export declare function inlineRegex(regex: RegExp): MatchFunction;
/** Creates a match function for a block scoped element from a regex */
export declare function blockRegex(regex: RegExp): MatchFunction;
/** Creates a match function from a regex, ignoring block/inline scope */
export declare function anyScopeRegex(regex: RegExp): MatchFunction;
export declare function unescapeUrl(rawUrlString: string): string;
/**
 * Parse some content with the parser `parse`, with state.inline
 * set to true. Useful for block elements; not generally necessary
 * to be used by inline elements (where state.inline is already true.
 */
export declare function parseInline(parse: Parser, content: string, state: ParserState): import("./type").ASTNode[];
export declare function parseBlock(parse: Parser, content: string, state: ParserState): import("./type").ASTNode[];
export declare function parseCaptureInline(capture: RegExpMatchArray, parse: Parser, state: ParserState): {
    content: import("./type").ASTNode[];
};
export declare function ignoreCapture(): {};
export declare function sanitizeUrl(url?: string): string | null;
